=== debian/changelog ===
mariadb-connector-odbc (3.1.15-5) unstable; urgency=medium

  * Cherry-Pick another upstream fix for #1108121

 -- Bernhard Schmidt <berni@debian.org>  Mon, 23 Jun 2025 14:47:07 +0200

mariadb-connector-odbc (3.1.15-4) unstable; urgency=medium

  * Import upstream fix for a Segmentation fault in SQLFetch (Closes: #1108121)

 -- Bernhard Schmidt <berni@debian.org>  Fri, 20 Jun 2025 22:18:48 +0200

mariadb-connector-odbc (3.1.15-3) unstable; urgency=medium

  * Add simple autopkgtest

 -- Bernhard Schmidt <berni@debian.org>  Sun, 30 Jan 2022 23:10:41 +0100

mariadb-connector-odbc (3.1.15-2) unstable; urgency=medium

  * Patch build system to find unixodbc libraries on all
    64bit architectures (might fix #942412)

 -- Bernhard Schmidt <berni@debian.org>  Fri, 28 Jan 2022 16:08:51 +0100

mariadb-connector-odbc (3.1.15-1) unstable; urgency=medium

  [ Faustin Lammler ]
  * Missing dependency on odbcinst (Closes: #1001141)

  [ Bernhard Schmidt ]
  * New upstream version 3.1.15
  * Update d/watch to Github, download page is outdated
  * d/rules: Use INSTALL_LAYOUT=DEB

 -- Bernhard Schmidt <berni@debian.org>  Fri, 28 Jan 2022 10:33:28 +0100
