=== debian/changelog ===
mariadb-connector-odbc (3.2.6-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport upstream fix for FTBFS with GCC 15. (Closes: #1114200)

 -- Adrian Bunk <bunk@debian.org>  Tue, 07 Oct 2025 17:54:03 +0300

mariadb-connector-odbc (3.2.6-1) unstable; urgency=medium

  [ Bernhard Schmidt ]
  * New upstream version 3.2.6 (Closes: #1106673)
    - Remove patches obsoleted upstream
    - d/copyright: adjust paths
  * Drop dh-make boilerplate from d/watch
  * Drop obsolete lintian override

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Bump debhelper from old 12 to 13.
  * Set upstream metadata fields: Repository-Browse.
  * Set upstream metadata fields: Repository.
  * Update standards version to 4.6.2, no changes needed.

  [ Bastian Triller ]
  * debian/control: Update URL to homepage

 -- Bernhard Schmidt <berni@debian.org>  Thu, 21 Aug 2025 20:08:57 +0200
