=== debian/control ===
--- 
+++ 
@@ -2,13 +2,13 @@
 Priority: optional
 Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
 Uploaders: Bernhard Schmidt <berni@debian.org>
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
 	cmake,
 	libmariadb-dev,
 	unixodbc-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Section: database
-Homepage: https://mariadb.com/kb/en/library/mariadb-connector-odbc/
+Homepage: https://mariadb.com/docs/connectors/mariadb-connector-odbc
 Vcs-Browser: https://salsa.debian.org/mariadb-team/mariadb-connector-odbc
 Vcs-Git: https://salsa.debian.org/mariadb-team/mariadb-connector-odbc.git
