=== debian/rules ===
--- 
+++ 
@@ -14,4 +14,3 @@
 		-DINSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH)/odbc \
 		-DINSTALL_DOCDIR=share/doc/odbc-mariadb \
 		-DINSTALL_LICENSEDIR=share/doc/odbc-mariadb
-
