=== debian/tests/control ===
Tests: mysql-query
Depends: mariadb-server, odbc-mariadb, unixodbc
Restrictions: needs-root isolation-container
