=== debian/watch ===
version=4

opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/mariadb-connector-odbc-$1\.tar\.gz/ \
  https://github.com/mariadb-corporation/mariadb-connector-odbc/tags .*/(\d\S+)\.tar\.gz
